// Ball.
//  update: 22.11.03 22:15


#include "Ball.h"

#include "allegro.h"

#include "Canvas.h"


#include "sys_include.h"


using namespace std;


const float PI = 3.141592654f;

// float to int with rounding
#define FI(f) (int((f) + 0.5f))


/////////////////////////////////// PUBLIC ///////////////////////////////////

// ** START ********************* lifecycle ******************************* //


Ball::Ball()
{
    //init(); 
}


// ** END *********************** lifecycle ******************************* //

// ** START ********************* operators ******************************* //
// ** END *********************** operators ******************************* //


void Ball::update()
{
    float dummy = timestep / m;
    vx += dummy * fx;
    vy += dummy * fy;
    vx *= 1 - damping;
    vy *= 1 - damping;

    // s = v0*t + a*t*t/2
    x += vx * timestep + fx / m * timestep * timestep / 2;
    y += vy * timestep + fy / m * timestep * timestep / 2;

    fx = fy = 0;
}


void Ball::init()
{
    x = y = vx = vy = fx = fy = 0;
    m = 3; radius = 15; damping = 0.00001;
    color = makecol(190, 153, 255);
    timestep = 0.1;
    //color = makecol(255, 255, 200);

    damping = get_config_float("Game", "ball_damping", 0.00001);
    radius = get_config_float("Game", "ball_radius", 15);
    m = get_config_float("Game", "ball_mass", 15);
}


void Ball::draw(Canvas* pDest, float ox, float oy)
{
    assert(pDest);

    BITMAP* canvas = pDest->mpGetAllegro();

    circlefill(canvas, FI(x + ox), FI(y + oy), FI(radius), color);
}


///////////////////////////////// PROTECTED //////////////////////////////////

////////////////////////////////// PRIVATE ///////////////////////////////////


