// Cave.
//  update: 23.11.03 11:01


#ifndef __CAVE_H__
#define __CAVE_H__


#include <vector>


class Canvas;
class Ball;


#include "sys_include.h"


class Cave
{
public:

    Cave();
    ~Cave();
    
    // 200, 20, 180, 10
    void generate(int segnum, float seglen, float amplitude, int smooth);
    void handleBall(Ball* ball);
    void translate(float dx, float dy);
    // rotates around the first generated point. top-left usually.
    void rotate(float degree);
    
    void draw(Canvas* pDest, float ox, float oy);

    // return base coordinates.
    void baseStartCoord(float* x, float* y);
    void baseEndCoord(float* x, float* y);

    // was ball-cave contact last handleBall()?
    bool was_contact;
    float contact_normal_x;
    float contact_normal_y;
    float contact_x;
    float contact_y;
    
private:

    struct CavePiece {
        CavePiece();
        float x1, y1, x2, y2;
        int color;
    };
    
    std::vector<CavePiece> m_cave;
    
    Ball* m_ball;
};


#include "sys_include_end.h"


#endif

