// FpsCounter.cpp: implementation of the FpsCounter class.
//
//////////////////////////////////////////////////////////////////////

#include "FpsCounter.h"


#include "sys_include.h"


using namespace std;



void FpsCounter::Tick(void)
{
	mCount++;

    mElapsedTime += mTicker.Tick();

	if (mElapsedTime >= mOutputUpdateTime) {
		mFps = mCount / mElapsedTime;
		mCount = 0.0f;
		mElapsedTime = 0.0f;
	}
}


float FpsCounter::GetFreq(void) const
{
	//loginf << mCount << endl;
	//loginf << mOutputUpdateTime << endl << endl;
	return mFps;
}


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////


FpsCounter::FpsCounter(float updateFreqency)
{
    if (updateFreqency > 0.0f) mOutputUpdateTime = 1.0 / updateFreqency;
	    else mOutputUpdateTime = 0.0f;

    mElapsedTime = 0.0f;
	mFps = 0.0f;
	mCount = 0.0f;
}


FpsCounter::~FpsCounter()
{

}
