// Jelly.
//  update: 11.06.03 23:26


#ifndef __JELLY_H__
#define __JELLY_H__


#include <vector>


class Canvas;
class Ball;


#include "sys_include.h"


struct MassPoint
{
    MassPoint();
    
    float x, y;
    //float prev_x, prev_y;
    float vx, vy;
    float fx, fy;
    float m;
    
    // shoud not change position.
    bool anchor;
    
    int color;
    bool visible;
};


struct Spring
{
    Spring();

    float l; // rest length
    float k; // stiffness
    float damping;
    
    MassPoint *p1, *p2;

    int color;
    bool visible;
    bool outer_edge;
};


// NEVER call generate... methods before allegro graphics is all set up.
class Jelly
{
public:

    Jelly();
    virtual ~Jelly();

    // left-most (top) coordinate will be 0, 0.
    // down-side will be stationary. call makeIndependent() to make it .. ind..
    void generateTriangular(float springLen, int xNum, int yNum);
    void generateBlob(float baseLen, float height, int topsurfaceNum);
    void generateRectangular(float springLen, int xNum, int yNum);
    void setData(float k) {}
    void translate(float dx, float dy);
    // rotates around the first generated mass-point. top-left usually.
    void rotate(float degree);
    // calculate next shape.
    void update();
    void draw(Canvas* pDest, float ox, float oy);

    void handleBall();

    std::vector<Spring> springs;
    std::vector<MassPoint> masspoints;

    float damping;
    float m;
    float timestep;
    
    // has to be initialized. if you want some collision response.
    Ball* ball;

    // return base coordinates.
    void baseStartCoord(float* x, float* y);
    void baseEndCoord(float* x, float* y);
    
    // counts ball-jelly contacts..
    int contacts;
    
    // was ball-cave contact last handleBall()?
    bool was_contact;
    float contact_normal_x;
    float contact_normal_y;
    float contact_x;
    float contact_y;
    
    
private:

    MassPoint* m_base_start;
    MassPoint* m_base_end;
    
    int jelly_internals_visible;
    int jelly_base_visible;
    int jelly_points_visible;
    
};


#include "sys_include_end.h"


#endif

