#include "Magnifier.h"


#include "allegro.h"


#include "Canvas.h"
#include "Recta.h"


#include "sys_include.h"


using namespace std;



void Magnifier::Magnify(Canvas& rSpic, Canvas* pDpic, Recta& rSource, Recta& rDest)
{
	assert(NULL != pDpic);

	BITMAP* d_pic = pDpic->mpGetAllegro();
	BITMAP* s_pic = rSpic.mpGetAllegro();

	if (is_screen_bitmap(s_pic) || is_video_bitmap(s_pic)) {
		logmsg << "The magnifier can't magnify an allegro video_- or screen_bitmap." << endl;
		return;
	}

	if (is_same_bitmap(s_pic, pDpic->mpGetAllegro())) {
		logmsg << "The magnifier can't magnify on the same allegro bitmap. Don't know why :(" << endl;
		return;
	}

	float sx, sy, sw, sh;
	sx = rSource.Ulx();
	sy = rSource.Uly();
	sw = rSource.Xsize();
	sh = rSource.Ysize();
	if (sx < 0) sx = 0;
	if (sy < 0) sy = 0;
	if (rSpic.Xsize() <= sx + sw) sw = rSpic.Xsize() - sx - 1;
	if (rSpic.Ysize() <= sy + sh) sh = rSpic.Ysize() - sy - 1;


	float dx, dy, dw, dh;
	dx = rDest.Ulx();
	dy = rDest.Uly();
	dw = rDest.Xsize();
	dh = rDest.Ysize();


	//rect(d_pic, dx - 2, dy - 2, dx + dw + 1, dy + dh + 1, makecol(255, 200, 100));
	//rect(d_pic, dx - 1, dy - 1, dx + dw, dy + dh, makecol(255, 255, 255));
	rect(d_pic, int(dx - 1), int(dy - 1), int(dx + dw), int(dy + dh), makecol(170, 170, 170));
	
	//rect(d_pic, sx - 2, sy - 2, sx + sw + 1, sy + sh + 1, makecol(255, 200, 100));
	rect(d_pic, int(sx - 1), int(sy - 1), int(sx + sw), int(sy + sh), makecol(128, 128, 128));

	stretch_blit(rSpic.mpGetAllegro(), d_pic, (int)sx, (int)sy,
											(int)sw, (int)sh,
											(int)dx, (int)dy,
											(int)dw, (int)dh);
}



Magnifier::Magnifier()
{

}


Magnifier::~Magnifier()
{

}

