// Mouse.
//  update: 11.06.03 23:26


#ifndef __MOUSE_H__
#define __MOUSE_H__


#include "Canvas.h"


#include "sys_include.h"


// multiple instances do not work.

// Main reason of this class: to not draw the mouse cursor, when the cursor is not inside this
// programs window. Uses the fact that mouse_x&mouse_y do not change when cursor outside, but
// get_mouse_mickeys() still returns movement.
//
// Gets updated only when calling Polll().

// and. has to be constructed after set_gfx_mode().
class Mouse
{
public:

	Mouse();
    ~Mouse();

    void Poll();

	const float X(void) const { return mX; }
	const float Y(void) const { return mY; }
	const int Button(void) const { return mButton; }
	const float PrevX(void) const { return mPrevX; }
	const float PrevY(void) const { return mPrevY; }
	const int PrevButton(void) const { return mPrevButton; }

	// Every time, after Draw, Erase has to be called.
	void Draw(Canvas* pDest, float upLx, float upLy);

    void Erase(Canvas* pDest, float upLx, float upLy);
    
    void Coverage(RectMesh* pMesh, float x, float y);


private:

    Canvas mMouseBack;
    Canvas mMouseSprite;

	int mBackX, mBackY;

	int mPrevX, mPrevY, mPrevButton;
    int mX, mY, mButton;

    int mMouseMickyX, mMouseMickyY;
    int mXdif, mYdif; // to displace the cursor sprite

	bool mOutside;
	bool mLocalMouseSprite; // true if allegro has'nt got any
};


#include "sys_include_end.h"


#endif

