// PulseGenerator.h: interface for the PulseGenerator class.
//  update: 22.11.03 15:35


#ifndef __PULSEGENERATOR_H__
#define __PULSEGENERATOR_H__


#include <list>


class iObserver;


#include "iConnection.h"
#include "SmartPtr.h"


#include "Ticker.h"


#include "sys_include.h"


// NB! NO SYNC! this way it's simpler and more useful for game menu like things.
// well, not quite. lets see.
class PulseGenerator
{
public:

	PulseGenerator();
	virtual ~PulseGenerator();

    //typedef boost::function<void (PulseGenerator*) > ObserverType;
    
    // return: a code you can use on Detach
    //SmartPtr<iConnection> Attach(ObserverType obs);
    SmartPtr<iConnection> Attach(iObserver* obs);

    // Notifies all attached clients. If neccessary of course.
    // Call this in your .. loop. main-loop. somewhere.
	void Notify();


    // Set the state to be used for next Attach call. For the next attached
    // object.
    // And read the state after the last Notify call. blabla. Don't have time
    // to document :( :( :(((


    // STATE
    

    // if freq is negative, then the observer is updated every time Notify()
    // is called.
    void Freq(float f);
    float Freq();
    
	// doPause: if true, then
	// fe. if freqency is 5Hz, then there will be a 1/5s pause before the
    // first call. 
    void DoPause(bool b);
    bool DoPause();


// temporary.debug
private:

    // genconnection only calls mDetach(). nothing else.
    friend class PulseGeneratorConnection;
    
    // only PulseGeneratorConnection should use this.
	void mDetach(int code);
	
    typedef struct mTimeStruct
    {
        float freq; // observer update frequency
		int obs_code; // observer code. given by Attach()
        // time-point of last change (called p_observer->Update()). not quite. time-point of when
		// the last Update call should have been.
		uint64 last_counts;
		iObserver* observer;
		iConnection* connection;
		bool firstly_pause;
	};

	typedef std::list<mTimeStruct> mObserversType;

	mObserversType mObservers;
	mObserversType::iterator mLastErased;

	// Just a counter. Every Attach() increases it by one. Detach() decreases.
	// Shows how many listeners-clients this object has.
	int mObsCounter; // But actually not used at all.

    // How many Attach'es. used for the obs_code.
	int mAttachCounter;


    // State variables. Used only when Attach() is called.
	float mFreq;
    bool mbPause;


	Ticker mTicker;
};


#include "sys_include_end.h"


#endif

