// ... class, by ETM.
//  update: 18.03.03 20:03


#include "RectMesh.h"

#include "Canvas.h"

#include "sys_include.h"


// NB! I don't remember if this is ok for negative numbers. Probably not. Off by 1 (or -1) sometimes.
//#define FLOOR(x) { if ((x) >= 0) return int(x); else return int(x) - 1; }
int FLOOR(float x) { if ((x) >= 0) return int(x); else return int(x) - 1; }
	
using namespace std;


/////////////////////////////////// PUBLIC ///////////////////////////////////


// ** START ********************* lifecycle ******************************* //


RectMesh::RectMesh()//: mDebugLevel(0), mCurNumRects(0)
{
}


// ** END *********************** lifecycle ******************************* //

// ** START ********************* operators ******************************* //
// ** END *********************** operators ******************************* //

// ** START ********************* operations ****************************** //


// First clip, then translate.
void RectMesh::Clip(Recta& rClipRect, float x, float y)
{
	mIterType i2;

	mIterType i = mRects.begin();

   	while (i != mRects.end()) {
		
		if (!(*i).Clip(rClipRect)) { 
			i2 = i; i++;
			mRects.erase(i2);
		} else {
			i->Translate(x, y);
			i++;
		}
	}
}


// Just clip. A bit faster than the other Clip method, cause it skips the translation part.
void RectMesh::Clip(Recta& rClipRect)
{
	mIterType i2;

	mIterType i = mRects.begin();

   	while (i != mRects.end()) {
		
		if (!(*i).Clip(rClipRect)) { 
			i2 = i; i++;
			mRects.erase(i2);
		} else i++;
	}
}


// First, translate the given mesh. Then clip & make it current (*this).
void RectMesh::SetClipped(RectMesh& rMesh, Recta& rClipRect, float x, float y)
{
	mRects.clear();

	Recta rect;
	
   	for (mIterType i = rMesh.mRects.begin(); i != rMesh.mRects.end(); i++) {
		rect = *i;
		rect.Translate(x, y);
		//rect.SetPos(i->GetUlx() + x, i->GetUly() + y);
		//rect.SetSize(i->GetXsize(), i->GetYsize());
		
		if (rect.Clip(rClipRect)) mRects.push_back(rect);
	}
}


void RectMesh::Cut(RectMesh& rMesh, float x, float y)
{
	assert(&rMesh != this);

	mIterType i_buf, i;
    int size;

   	for (mIterType i2 = rMesh.mRects.begin(); i2 != rMesh.mRects.end(); i2++) {
	    //size = mCurNumRects;
	    size = mRects.size();
		i = mRects.begin();
		
		Recta r = *i2;
		r.Translate(x, y);

		for (int a = 0; a < size; a++) {
			if (i->IsOverlapping(r)) {
				i_buf = i; i++;
				mCutRect(r, i_buf);
			} else i++;
		}
	}
}


/*
void RectMesh::Cut(RectMesh& rMesh)
{
	assert(&rMesh != this);

	mIterType i_buf, i;
    int size;

   	for (mIterType i2 = rMesh.mRects.begin(); i2 != rMesh.mRects.end(); i2++) {
	    size = mCurNumRects;
		i = mRects.begin();

		for (int a = 0; a < size; a++) {
			if (i->IsOverlaping(*i2)) {
				i_buf = i; i++;
				mCutRect(*i2, i_buf);
			} else i++;
		}
	}
}
*/

/*

void RectMesh::Join(RectMesh& rMesh)
{
	assert(&rMesh != this);

    for (mIterType i = rMesh.mRects.begin(); i != rMesh.mRects.end(); i++) AddRect(*i);
}
*/

void RectMesh::Join(RectMesh& rMesh, float x, float y)
{
	assert(&rMesh != this);

    for (mIterType i = rMesh.mRects.begin(); i != rMesh.mRects.end(); i++) 
		AddRect(i->Ulx() + x, i->Uly() + y, i->Xsize(), i->Ysize());
}


void RectMesh::AddRect(Recta& rRect)
{ 
	// mDeleteOverlap can add some rectangles to mRects. 
	// So we use mCurNumRects. STL's size can be slow for list.
	mIterType i_buf, i = mRects.begin();

    if (i != mRects.end())
	do {
        if (i->IsOverlapping(rRect)) {
			if (rRect.IsInside(*i)) {
				return; // new rect completely inside some other.
			} else {
				i_buf = i; i++;
			    mCutRect(rRect, i_buf);
			}
		} else i++;
	} while (i != mRects.end());

	mRects.push_back(rRect); //mCurNumRects++;
}


void RectMesh::AddRect(float uLx, float uLy, float xSize, float ySize)
{
    Recta rect;

	rect.Pos(uLx, uLy);
	rect.Size(xSize, ySize);
	AddRect(rect);
}


void RectMesh::AddRectPos(float centerX, float sizeX, float centerY, float sizeY)
{
    Recta rect;

	rect.Pos(centerX - sizeX / 2.0f, centerY - sizeY / 2.0f);
	rect.Size(sizeX, sizeY);
	AddRect(rect);
}

/*
void RectMesh::Blit(Canvas& rSource, Canvas* pDest)
{
	Blit(rSource, pDest, 0, 0);
}


// not pixel centers






// bottom-right fill-convention

// blaa-blaa-blaa. eh. whatever.
void RectMesh::Blit2(Canvas& rSource, Canvas* pDest, float x, float y, float x2, float y2)
{
	for (mIterType i = mRects.begin(); i != mRects.end(); i++) {

		float xs_helper = i->GetUlx() - x + 0.5f;
		float xs = FLOOR(xs_helper + i->GetXsize()) - FLOOR(xs_helper);
		float ys_helper = i->GetUly() - y + 0.5f;
		float ys = FLOOR(ys_helper + i->GetYsize()) - FLOOR(ys_helper);

	    rSource.Draw(pDest, i->GetUlx() - x2, i->GetUly() - y2, 
			                x + i->GetUlx(), y + i->GetUly(), xs, ys);

		// display all rectangles. if debugging, that is.
		if (2 == mDebugLevel || -1 == mDebugLevel) {
			static int col, dir = -1, speed = 2;
			pDest->Recta(i->GetUlx(), i->GetUly(),
				        i->GetDrx() - 1.0f, i->GetDry() - 1.0f, col, 0, 255 - col);
   			col += dir * speed;
			if (255 <= col || 0 > col) { dir = -dir; col += dir * speed; }
		}
	}
}


// bottom-right fill-convention












void RectMesh::Blit(Canvas& rSource, Canvas* pDest, float x, float y)
{
//	Recta clip_rect;
//	clip_rect.SetPos(x, y);
//	clip_rect.SetSize(rSource.GetXSize(), rSource.GetYSize());

	Recta rect;

	for (mIterType i = mRects.begin(); i != mRects.end(); i++) {

		rect = *i;

//		rect.Clip(clip_rect);

//		if (rect.GetXsize() != 0 && rect.GetYsize() != 0) 
		{
#ifdef 0		
		loginf << "x = " << x << endl;
		loginf << "y = " << y << endl;
		loginf << "ulx = " << i->GetUlx() << endl;
		loginf << "uly = " << i->GetUly() << endl;
		loginf << "usx = " << i->GetXsize() << endl;
		loginf << "usy = " << i->GetYsize() << endl;

    	loginf << endl;
		
		loginf << "rectulx = " << rect.GetUlx() << endl;
		loginf << "rectuly = " << rect.GetUly() << endl;
		loginf << "rectusx = " << rect.GetXsize() << endl;
		loginf << "rectusy = " << rect.GetYsize() << endl;

    	loginf << endl;
    	loginf << endl;
#endif

		// +0.5, 'cause we are interested in pixel centers.
		// and these rects are completely around pictures.
		// blahblahblah. another month to decipher this.

		// well, this is old anyway. things have changed much since.

		// there are still some problems with the position.. perfect scan-conversion problem.

		float xs_helper = rect.GetUlx() - x + 0.5f;
		float xs = FLOOR(xs_helper + rect.GetXsize()) - FLOOR(xs_helper);
		float ys_helper = rect.GetUly() - y + 0.5f;
		float ys = FLOOR(ys_helper + rect.GetYsize()) - FLOOR(ys_helper);

		
		// sub-sprite with alpha not supported by allegro. damn!
		//if (rect.GetUlx() - x == 0 && rect.GetUly() - y == 0 &&
		//	xs == rect.GetXsize() && ys == rect.GetYsize()) 
		if (rect.GetUlx() == 0 && rect.GetUly() == 0)
			//&& pDest->GetXSize() == rect.GetXsize() && pDest->GetYSize() == rect.GetYsize()) 
		//if (rect.GetUlx() - x == 0 && rect.GetUly() - y == 0)
		{
//			loginf << "x = " << x << "   y = " << y << endl;
		    rSource.Draw(pDest, rect.GetUlx(), rect.GetUly(), x, y, xs, ys);
		    //rSource.Draw(pDest, x, y);
		} else {
		    //rSource.Draw(pDest, rect.GetUlx() - x, rect.GetUly() - y,
	    	//	 		 rect.GetUlx(), rect.GetUly(), xs, ys);
		}
			loginf << "x = " << x << "   y = " << y << endl;
			loginf << "rect.GetUlx() = " << rect.GetUlx() << "   rect.GetUly() = " << rect.GetUly() << endl;
		    //rSource.Draw(pDest, rect.GetUlx(), rect.GetUly(), x, y, xs, ys);


		//rSource.Draw(pDest, rect.GetUlx() - x, rect.GetUly() - y,
		//	 		 rect.GetUlx(), rect.GetUly(), rect.GetXsize(), rect.GetYsize());

		// display all rectangles. if debugging, that is.
		if (2 == mDebugLevel || -1 == mDebugLevel) {
			static int col, dir = -1, speed = 2;
			pDest->Recta(i->GetUlx(), i->GetUly(),
				        i->GetDrx() - 1.0f, i->GetDry() - 1.0f, col, 0, 255 - col);
   			col += dir * speed;
			if (255 <= col || 0 > col) { dir = -dir; col += dir * speed; }
		}
		}
	}
}


// not pixel centers

void RectMesh::DebugDraw(Canvas* pDest)
{
	for (mIterType i = mRects.begin(); i != mRects.end(); i++)
		pDest->Recta(i->GetUlx(), i->GetUly(),
			        i->GetDrx() - 1.0f, i->GetDry() - 1.0f, 100, 255, 128);
}

*/

// pixel edges. 0, 0 in rects is the pixel edge. 0.5, 0.5 is the center.

// + 0.5 & - 0.5 IS correct. contours should be inside. that's why.

void RectMesh::Translate(float x, float y)
{
	for (mIterType i = mRects.begin(); i != mRects.end(); i++)
		i->Translate(x, y);
}


void RectMesh::DebugDraw(Canvas* pDest, float x, float y)
{

	for (mIterType i = mRects.begin(); i != mRects.end(); i++)
		pDest->Rect(i->Ulx() + x + 0.5f, i->Uly() + y +  + 0.5f,
			        i->Drx() + x - 0.5f, i->Dry() + y - 0.5f, 100, 255, 128);

/*
    // Draw only upper half.
	for (mIterType i = mRects.begin(); i != mRects.end(); i++)
	{
        float dx = (i->Drx() - i->Ulx()) / 2;
        float dy = (i->Dry() - i->Uly()) / 2;

		pDest->Rect(i->Ulx() + x + 0.5f, i->Uly() + y + 0.5f,
			        i->Drx() + x - 0.5f, i->Dry() + y - 0.5f - dy, 100, 255, 128);
    }
*/
}



// ** END *********************** operations ****************************** //

// ** START *********************** access ******************************** //
// ** END ************************* access ******************************** //

// ** START ********************** inquiry ******************************** //
// ** END ************************ inquiry ******************************** //

///////////////////////////////// PROTECTED //////////////////////////////////

////////////////////////////////// PRIVATE ///////////////////////////////////


// Send only overlapping rectangles! Or I don't know what will happen.
// user has to delete the remainig rectangle. old.

// Efficient when the new rectangle tends to be bigger than old ones.
void RectMesh::mCutRect(Recta& rNew, mIterType& rOld)
{
    // some old rect behind the new one. delete the old one.
    if (rOld->IsInside(rNew)) {
        mRects.erase(rOld); //mCurNumRects--;
		return;
	}

	// Ok. Now there has to be some kind of partial overlap.

    Recta rect;

	// old rect partially higher than new.
	if (rOld->Uly() < rNew.Uly()) {
		// insert one completely non-overlapping rect. (the part of old one that was higher)
		rect = *rOld; 
		rect.Dry(rNew.Uly());
		rOld->Uly(rNew.Uly());
		mRects.push_back(rect); //mCurNumRects++;
	}

	// old rect partially lower than new.
	if (rOld->Dry() > rNew.Dry()) {
		rect = *rOld; 
		rect.Uly(rNew.Dry());
		rOld->Dry(rNew.Dry());

		mRects.push_back(rect); //mCurNumRects++;
	}

	// old rect partially left of new.
	if (rOld->Ulx() < rNew.Ulx()) {
		rect = *rOld; 
		rect.Drx(rNew.Ulx());
		rOld->Ulx(rNew.Ulx());

		mRects.push_back(rect); //mCurNumRects++;
	}

	// old rect partially right of new.
	if (rOld->Drx() > rNew.Drx()) {
		rect = *rOld; 
		rect.Ulx(rNew.Drx());
		rOld->Drx(rNew.Drx());

		mRects.push_back(rect); //mCurNumRects++;
	}

	// And now, the remainig rectangle is completely behind the new one. delete. user should.

    mRects.erase(rOld); //mCurNumRects--;
    // necessary modifications to mRects's rectangles made. 
}

