// Simple rectangle class, by ETM.
//  update: 2003.01.23


#include "Recta.h"

#include "sys_include.h"


using namespace std;


/////////////////////////////////// PUBLIC ///////////////////////////////////

// ** START ********************* lifecycle ******************************* //


Recta::Recta()
{
    mUlx = mUly = mDrx = mDry = 0;
}


// ** END *********************** lifecycle ******************************* //

// ** START ********************* operators ******************************* //
// ** END *********************** operators ******************************* //


void Recta::Translate(float x, float y)
{
    mUlx += x; mUly += y;
    mDrx += x; mDry += y;
}


// up-left
void Recta::Pos(float uLx, float uLy)
{
    mDrx += uLx - mUlx;
    mDry += uLy - mUly;
    mUlx = uLx; mUly = uLy;
}


// up-left point is stationary.
void Recta::Size(float xSize, float ySize)
{
	//mXsize = xSize; mYsize = ySize; assert(0 < mXsize && 0 < mYsize);
	// Is it ok to be 0 <= ?. don't remember, if anything relied on that.
	//mXsize = xSize; mYsize = ySize;
    //assert(0 <= mXsize && 0 <= mYsize);

	mDrx = xSize + mUlx;
    mDry = ySize + mUly;
    assert(0 <= mDrx - mUlx && 0 <= mDry - mUly);
}


// down-right point coordinates stay.
void Recta::Ulx(float x)
{
    //mXsize += mUlx - x; mUlx = x; assert(0 < mXsize);
    mUlx = x; assert(0 < mDrx - mUlx);
}


void Recta::Uly(float y)
{
    mUly = y; assert(0 < mDry - mUly);
/*
        float yy1 = mYsize;
        float my1 = mUly;
        float oriy1 = y;

        float aa1 = 3;
*
    mYsize += mUly - y; mUly = y;

    if (mYsize <= 0)
    {
        float yy = mYsize;
        float my = mUly;
        float oriy = y;
        
        float aa = 3;
    }
    
    
    assert(0 < mYsize);
*/
}


// up-left point coordinates stay.
void Recta::Drx(float x)
{
    //mXsize = x - mUlx; assert(0 <= mXsize);
    mDrx = x; assert(0 < mDrx - mUlx);
}


void Recta::Dry(float y)
{
    //mYsize = y - mUly; assert(0 <= mYsize);
    mDry = y; assert(0 < mDry - mUly);
}


// clips the current rectangle, so it fits inside the given one.
// if the current rectangle is completely outside the given rect, no changes will be made
// and return false. if all ok, return true.
bool Recta::Clip(Recta& clipRect)
{
	if (!IsOverlapping(clipRect)) return false;

	if (mUlx < clipRect.mUlx) Ulx(clipRect.mUlx);
	if (mUly < clipRect.mUly) Uly(clipRect.mUly);
	if (Drx() > clipRect.Drx()) Drx(clipRect.Drx());
	if (Dry() > clipRect.Dry()) Dry(clipRect.Dry());

	return true;
}


// resizes the rectangle, so it contains the given coordinates.
void Recta::Contain(float x, float y)
{
	if (x < mUlx) Ulx(x);
	if (y < mUly) Uly(y);

	if (x > mDrx) Drx(x);
	if (y > mDry) Dry(y);
}


// ACCESS ----------------------------------------------------------------


float Recta::Ulx(void) const { return mUlx; }
float Recta::Uly(void) const { return mUly; }

float Recta::Drx(void) const { return mDrx; }
float Recta::Dry(void) const { return mDry; }

float Recta::Xsize(void) const { return mDrx - mUlx; }
float Recta::Ysize(void) const { return mDry - mUly; }


// INQUIRY ---------------------------------------------------------------


// Overlapping is overlapping. When fe. only two edges coincidence, it's not overlapping.
bool Recta::IsOverlapping(Recta& rRect)
{
    if (rRect.mUly >= mDry) return false; // rRect up
    if (rRect.mDry <= mUly) return false; // rRect down
    if (rRect.mUlx >= mDrx) return false; // rRect right
    if (rRect.mDrx <= mUlx) return false; // rRect left

	return true; // overlapping then ...
}


// If this rect is inside the rRect. Edges can overlap.
bool Recta::IsInside(Recta& rRect)
{
    if (rRect.mUlx <= mUlx &&
        rRect.mDrx >= mDrx &&
        rRect.mUly <= mUly &&
        rRect.mDry >= mDry) return true;

	return false; // not inside. at least not completely.
}


bool Recta::Intersects(float x, float y)
{
    if (mUlx <= x && mDrx > x &&
        mUly <= y && mDry > y)
    return true;
    
    return false;
}


bool Recta::IsPoint()
{
    //if (0 == mXsize && 0 == mYsize) return true;
    if (mDrx == mUlx && mDry == mUly) return true;

	return false;
}


///////////////////////////////// PROTECTED //////////////////////////////////

////////////////////////////////// PRIVATE ///////////////////////////////////

