// Simple timer class, by ETM.
//  update: 06.02.2002


#ifndef _TICKER_H_
#define _TICKER_H_


#include "sys_include.h"


//////////////////////////////////////////////////////////////////////////////


// singleton... i guess... i hope...
class Ticker {

public:

    // LIFECYCLE -------------------------------------------------------------

    Ticker();

    // OPERATORS -------------------------------------------------------------

    // OPERATIONS ------------------------------------------------------------

    double ToSeconds(uint64 const count) const;
    // Returns elapsed time between two last Tick() calls.
	double GetElapsedTime(void) const;

	// Returns elapsed time since the last Tick() call. On first call returns
	// elapsed time from construction.
	double Tick(void);

    // ACCESS ----------------------------------------------------------------

    // Return the number of counts per second. (usually processor frequency)
    uint64 GetTimerFrequency(void) const;

    // Counts made by the timer (processor) so far.
	uint64 GetTimerCount(void);

    // INQUIRY ---------------------------------------------------------------

private:

	uint64 mPrevMomentCount;
	double mElapsedTime; // Time between last two Tick() calls.


	uint64 mFrequency;
    uint64 mCurrentCounts;
};


//////////////////////////////////////////////////////////////////////////////


#include "sys_include_end.h"


#endif

