// Platform independent API for system, by ETM.
// This program is in the public domain.
// Allegro version.
//  update: 04.04.03 23:09


#include <iostream>
#include <fstream>
#include <iomanip>

#include "allegro.h"

#include "sys_functions.h"

//#include "sys_include.h"

using namespace std;


// ** START ******************** declarations ***************************** //

// ** END ********************** declarations ***************************** //

// ** START ******************** definitions ****************************** //


ofstream loginf;

sys_functions sys;


// ** END ********************** definitions ****************************** //

// ** START ************** functions and procedures *********************** //
// ** END **************** functions and procedures *********************** //

// ** START ************** public member functions ************************ //


// returns !0 on error
int sys_functions::OSProcedure(void)
{
    return 0;
}


// ** END **************** public member functions ************************ //

// ** START ************** private member functions *********************** //


sys_functions::sys_functions()
{
    loginf.open("log.txt");
    if (!loginf) {
        cout << "Output file - log.txt - cannot be opened. Quitting." << endl;
        exit(3);
    }

    allegro_init();
    loginf << "mail: Elmo.Trolla@mail.ee.\n";
    loginf << "www : http://www.blastnet.ee/etm/\n\n";
    loginf << "Allegro initialized.\n\n";

    loginf << "Information about system:" << endl;
    loginf << "  allegro info : " << allegro_id << endl;
    loginf << "  OS Type      : ";

    switch (os_type) {
        case OSTYPE_UNKNOWN: loginf << "allegro doesn't know" << endl; break;
        case OSTYPE_WIN3: loginf << "Windows 3.1 or earlier" << endl; break;
        case OSTYPE_WIN95: loginf << "Windows 95" << endl; break;
        case OSTYPE_WIN98: loginf << "Windows 98" << endl; break;
        case OSTYPE_WINNT: loginf << "Windows NT" << endl; break;
        case OSTYPE_OS2: loginf << "OS/2" << endl; break;
        case OSTYPE_WARP: loginf << "OS/2 Warp 3" << endl; break;
        case OSTYPE_DOSEMU: loginf << "Linux DOSEMU" << endl; break;
        case OSTYPE_OPENDOS: loginf << "Caldera OpenDOS" << endl; break;
        case OSTYPE_LINUX: loginf << "LINUX" << endl; break;
        case OSTYPE_UNIX: loginf << "Unknown Unix variant" << endl; break;

        default: loginf << "other (I think the sys_functions needs an update)" << endl;
    }

    loginf << endl;

    loginf << "  CPU info: " << endl;
    loginf << "    vendor: ";
    if (*cpu_vendor == 0) loginf << "unknown" << endl;
    else loginf << cpu_vendor << endl;

    loginf << "    family: " << cpu_family << "  (3=386, 4=486, 5=Pentium, 6=PPro, etc)" << endl;
    if (cpu_3dnow) loginf << "    3dnow! available" << endl;
    if (cpu_mmx) loginf << "    mmx available" << endl;
    if (cpu_fpu) loginf << "    fpu available" << endl;

    if (!cpu_cpuid) loginf << "  Previous CPU information may be inaccurate." << endl;

    loginf << endl << "System initialized.\n" << endl;
}


sys_functions::~sys_functions()
{
    loginf << endl << "System quit ok.\n" << endl;

    loginf.close();
}


// ** END **************** private member functions *********************** //

